// Created with MonoDevelop
//
//    Copyright (C) 2023 Hiperscan GmbH Dresden, Germany
//
//    This program is free software: you can redistribute it and/or modify
//    it under the terms of the GNU General Public License as published by
//    the Free Software Foundation, either version 3 of the License, or
//    (at your option) any later version.
//
//    This program is distributed in the hope that it will be useful,
//    but WITHOUT ANY WARRANTY; without even the implied warranty of
//    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
//    GNU General Public License for more details.
//
//    You should have received a copy of the GNU General Public License
//    along with this program.  If not, see <http://www.gnu.org/licenses/>.

using System;

using Hiperscan.Unix;
using Hiperscan.SGS.Common;
using Hiperscan.SGS.SerialInterface;
using static Hiperscan.SGS.SgsNt.Protocol.BaseProtocol;


namespace Hiperscan.SGS.SgsNt
{
    internal partial class DeviceNt1_5 : DeviceNt1_4
    {
        public DeviceNt1_5(DeviceInfo info, VersionInfo version) : base(info, version)
        {
        }

        public override void WriteSamplePositionDetection(SamplePositionDetectionData sample_positions)
        {
            Protocol.Command command = new SgsNt.Protocol.BaseProtocol.Command(Protocol.WriteSamplePositionDetection)
            {
                TransferStructValue = TransferStruct.GetBytes(sample_positions)
            };
            Protocol.Response response = this.WriteCommand(command, this.current_config.TimeoutMs);

            if (response == null)
                throw new SgsException(Catalog.GetString("Cannot read sample position detection."), this);
        }

        public override SamplePositionDetectionData ReadSamplePositionDetection()
        {
            this.CheckForExistingPeriphery();

            Protocol.Command command = new SgsNt.Protocol.BaseProtocol.Command(Protocol.ReadSamplePositionDetection);
            Protocol.Response response = this.WriteCommand(command, this.current_config.TimeoutMs);

            if (response == null)
                throw new SgsException(Catalog.GetString("Cannot read sample position detection."), this);

            return (SamplePositionDetectionData)TransferStruct.FromBuffer(response.TransferStructValue,
                typeof(SamplePositionDetectionData));
        }
    }
}